/*
	Xiliinx SpartanII Configrater with Cypress EZ-USB Ver.1.0

	Copyright(c) 2002 Tatsuyuki Satoh

	EEZ-USBgSpartanIIRtBO[V܂B
	ESpartanIĨVAX[u[hƁAoE_XL[hɑΉ
	E\[Xt@ĆAXilinx Webpacko͂bitstream
	@t@C(*.bit)ɑΉ܂B
	  Awb_̉ǂ100%ł͂Ȃ̂ŁAo[W
	  Ă͓Ȃ܂B

	note:

	@RpC̓t[̃RpCAMINGWgpĂ܂B

	@̃vÓAEZ-USBI/FɁACypressЂ́udy|trap̊J
	LbgvƃIveB}CÝuJIUSBvp̐\tgx[XɎg
	pĂ܂B

	@N"L"IvVƌJԂs[hɂȂAݐ
	Abitstreamt@C폜āAVɓÕt@C쐬
	̂҂܂B
	@vWFNgfBNgbitstreamt@Cݒ肵Ă΁AXilinx
	fUCc[ŃRpCAIɃ_E[h邱Ƃł܂B

	Histry
		2002. 3.19 Ver.0.9 T.Satoh
			- 1st release
		2002. 7.29 Ver.1.0 T.Satoh
		 	- Export probe function to DLL
*/
#include <windows.h>
#include <stdio.h>

#include "xilinxbit.h"	// Xilinx bistream file handler

// Maximum of file trasnfer size
#define TX_MAX 32768

// Config File Buffer
BYTE file_buffer[TX_MAX];

/* -------------------- PROBE hardware dependent interface macros -------------------- */
/*
	External Hardware Driver Function Pointers
	Dynamic Mapped from DLL driver
*/

// Shared (External)
static int (*sh_init)(DWORD,DWORD,char *);	// initialize PROBE & get name : jtag_init  / ss_init
static int (*sh_power)(void);				// sense TargetPower           : jtag_poewr / ss_power
static void (*sh_end)(void);				// end of PROBE controll       : jtag_end   / ss_end
// Shared (Internal)
static int (*sh_start)(void);				// Start Configration          : jtag_start / ss_start
static int (*sh_write)(BYTE *,DWORD,int);	// Write ConfigData            : jtag_write / ss_write

// JTAG Boundary Scan
static int (*jtag_txrx)(const BYTE *ibuf,BYTE *obuf,DWORD drsize,int tms_s,int tms_e); // JTAG access

// SlaveSerial interface
static int (*ss_tx)(const BYTE *data,DWORD size_bytes);	// TX configration data
static int (*ss_program)(BYTE level);					// controll -PROGRAM pin
static int (*ss_done)(void);							// sense DONE pin

/* macros of Hardware Driver Function */
#define PROBE_INIT(PARAM,BAUDRATE,PROBEINFO)  sh_init(PARAM,BAUDRATE,PROBEINFO)
#define PROBE_POWER()      sh_power()
#define PROBE_END()        sh_end()
#define JTAG_TXRX(IBUF,OBUF,SIZE,TMSS,TMSE) jtag_txrx(IBUF,OBUF,SIZE,TMSS,TMSE)
#define SS_TX(DATA,SIZE) ss_tx(DATA,SIZE)
#define SS_PROGRAM(LEVEL) ss_program(LEVEL)
#define SS_DONE() ss_done()
#define CONFIG_START() sh_start()
#define CONFIG_WRITE(B,S,L) sh_write(B,S,L)

/* -------------------- error status -------------------- */
#define ERROR_FILE   0x8000
#define ERROR_PROBE  0x4000
#define ERROR_TARGET 0x2000

/* -------------------- impact option command -------------------- */
enum{
	OPT_PORT,OPT_BAUD,OPT_MODE,OPT_BITSTREAM,OPT_JEDEC,OPT_DRIVER,OPT_BATCH,OPT_CONTINUE
};
static const char *impact_cmd[] =
{
	"-port",
	"-baud",
	"-mode",
	"-bitstream",
	"-jedec",
	"-driver",
	"-f",
	"-continue",
	NULL
};

enum{
	MODE_MS,MODE_BSCAN,MODE_SP,MODE_SS
};

static const char *mode_select[] =
{
	"mserial",		// master serial
	"bscan", 		// bscan
	"sparalell",	// sparallel
	"sserial", 		// sserial
	NULL
};

static const char *md_str[4] = { "MasterSerial","BoundaryScan","SlaveParallel","SlaveSerial"};

/* -------------------- Command Options -------------------- */

static int config_mode;
static int port_addr;
static int baudrate;
static int continus_mode;

//bitstream filename / dll driver name
static char filename[128], dll_name[128] , rsp_name[128];

/* -------------------- SerialSlave Configration -------------------- */

// e|[g̏
#define CF_RESET 0x00 // PROGRAM = L
#define CF_RUN   0x01 // PROGRAM = H
#define CF_DONE(port) ((port)&2)
#define CF_INIT(port) ((port)&4)
#define CF_VCC(port)  ((port)&8)

// CONFIG_START() : SerialSlave ConfigJn
int ss_start(void)
{
	// PROGRAMskɂB
	SS_PROGRAM(0);
	sleep(50);
	// PROGRAMsgɂ@*/
	SS_PROGRAM(1);
	sleep(50); /* INIT=HɂȂ܂ł܂ */

	return 0;
}

// SerialSlave ubNݏ
int ss_write(BYTE *data,DWORD size,int last)
{
	SS_TX(data,size);
	if(last)
	{
		// Check DONE pin = H
		if( SS_DONE() )
		{
			printf("DONE = H\n");
			return 0;
		}
		else
		{
			printf("DONE = L\n");
			return 1;
		}
	}
	return 0;
}

/* -------------------- BoundaryScan(JTAG) Configration -------------------- */
/*
	Xilinx XAPP188 (v2.0)
*/
#define CF_TMS 1
#define CF_TDO(port) ((port)&2)

/* StartanII JTAG Instructions */
#define EXTEST   0
#define SAMPLE   1
#define USER1    2
#define USER2    3
#define CFG_OUT  4
#define CFG_IN   5
#define INTEST   7
#define USERCODE 8
#define IDCODE   9
#define HIGHZ    10
#define JSTART   12
#define bypass   31

/* JTAG Command Code */
#define CMD_WCFG   0x01 /* 0001 write config */
#define CMD_LFRM   0x01 /* 0011 last frame   */
#define CMD_RCFG   0x04 /* 1110 read config  */
#define CMD_START  0x05 /* 1110 startup      */
#define CMD_RCAP   0x06 /* 1110 reset capture */
#define CMD_RCRC   0x07 /* 1110 reset CRC     */
#define CMD_AHIGH  0x08 /* 1110 GHIGH_B assert */
#define CMD_SWITCH 0x09 /* 1110 SWITCH */

// swap bits in BYTE data
static BYTE swap_byte(BYTE value)
{
	BYTE ret = 0;

	if(value&0x01) ret |= 0x80;
	if(value&0x02) ret |= 0x40;
	if(value&0x04) ret |= 0x20;
	if(value&0x08) ret |= 0x10;
	if(value&0x10) ret |= 0x08;
	if(value&0x20) ret |= 0x04;
	if(value&0x40) ret |= 0x02;
	if(value&0x80) ret |= 0x01;

	return ret;
}

// 4xBYTE to DWORD conversion (bigendian)
static DWORD byte_to_dword(BYTE *data)
{
	return (DWORD)data[3]*0x1000000 |
		   (DWORD)data[2]*0x10000   |
		   (DWORD)data[1]*0x100     |
		   (DWORD)data[0];
}

// swap bits in DWORD data
static DWORD swap_dword(DWORD value)
{
	DWORD ret = 0;
	int b;
	
	for(b=0;b<32;b++)
	{
		if( value & (1<<b) )
			ret |= 0x80000000>>b;
	}
	return ret;
}

// JTAG DR shift phase
void jtag_dr(const BYTE *ibuf,BYTE *obuf,int drsize,int finish)
{
	int c;

	if(finish)
	{
		JTAG_TXRX(ibuf,obuf,drsize,0,1);
		//update -DR state
		JTAG_TXRX(NULL,NULL,1,1,1);
	}
	else
		JTAG_TXRX(ibuf,obuf,drsize,0,0);
}

// JTAG Instruction Write
void jtag_inst(BYTE cmd,int need_reset,const BYTE *ibuf,BYTE *obuf,int drsize,int finish)
{
	// Logic reset +  run idle mode
	if(need_reset)
		JTAG_TXRX(NULL,NULL,6,1,0);

	// Enter SELECT-IR state : 2clock
	JTAG_TXRX(NULL,NULL,2,1,1);
	// Enter SHIFT-IR state : 2clock
	JTAG_TXRX(NULL,NULL,2,0,0);
	// Loading instruction & exiting SHIFT-IR
	cmd = swap_byte(cmd);
	JTAG_TXRX(&cmd,NULL,5,0,1);
	// Etner SELECT-DR state
	JTAG_TXRX(NULL,NULL,2,1,1);
	// Etner SHIFT-DR state
	JTAG_TXRX(NULL,NULL,2,0,0);

	if(drsize)
		jtag_dr(ibuf,obuf,drsize,finish);
}

// show status register
DWORD jtag_status(void)
{
	BYTE obuf[4];
	DWORD sts;
	static const BYTE sts_data[] = {
		0x28,0x00,0xe0,0x01,
		0x00,0x00,0x00,0x00 };

	static const char *md2_str[2] = { " Hi-z " , "Pullup"};
	static const char *hl_str[2] = { "H","L" };
	static const char *lock_str[2] = { "L","U" };
	static const char *yesno_str[2] = { "YES","NO " };
	static const char *err_str[2] = { "OK ","ERR" };

	// read status
	jtag_inst(CFG_IN,1,sts_data,NULL,sizeof(sts_data)*8,1);
	jtag_inst(CFG_OUT,0,NULL,NULL,1,0); // dummy 1 byte ?
	jtag_dr(NULL,obuf,32,1);

	sts = swap_dword(byte_to_dword(obuf));

	printf("FPGA Status :DONE:INIT:    MODE    (ports ):GWE:GSR:GHIGH:GTS:IER:LOCK:CRC:\n");
	printf("  %08X  :%s :%s :%s(%s): %s : %s :  %s  : %s : %s :%s%s%s%s:%s:\n",
		sts,
		yesno_str[sts&0x4000?0:1], // DONE
		yesno_str[sts&0x2000?1:0], // INIT
		md_str[(sts>>10)&3],md2_str[sts&0x1000?1:0],
		hl_str[(sts>>5)&1],		// GWE_B
		hl_str[(sts>>8)&1],		// GSR_B
		hl_str[(sts>>9)&1],		// GHIGH_B
		hl_str[(sts>>6)&1],		// GTS_CCFG
		hl_str[(sts>>5)&1],	// IN_ERROR
		lock_str[(sts>>1)&1],lock_str[(sts>>2)&1], // LOCK1 , LOCK2
		lock_str[(sts>>3)&1],lock_str[(sts>>4)&1], // LOCK3 , LOCK4
		err_str[sts&1]);		// CRC ERROR
	return sts;
}

// BS shutdown

DWORD jtag_shutdown(void)
{
	static const BYTE sht_data0[] =
{
	0x30,0x00,0x80,0x01, // ?.CMD write
	0x00,0x00,0x00,CMD_SWITCH,
	0x30,0x01,0x20,0x01, // 2.COR write
	0x00,0xa0,0xbf,0x2d, //       SHUTDOWN = 1
//	0x00,0x80,0xbf,0x2d, //       SHUTDOWN = 1 (err)

	0x30,0x00,0x80,0x01, // 3.CMD write
	0x00,0x00,0x00,CMD_START,
	0x30,0x00,0x80,0x01, // 4.CMD write
	0x00,0x00,0x00,CMD_RCRC,
	0x00,0x00,0x00,0x00}; // flush PIPE

	static const BYTE sht_data1[] =
{
	0x30,0x00,0x80,0x01, // 4.CMD AHIGH
	0x00,0x00,0x00,CMD_AHIGH,
	0x30,0x01,0x20,0x01, // 2.COR SHUTDOWN = 0
	0x00,0x80,0x3f,0x2d, //       SHUTDOWN = 0
	0x00,0x00,0x00,0x00}; // flush PIPE

	printf("FPGA shutdown\n");

	jtag_inst(CFG_IN,1,sht_data0,NULL,sizeof(sht_data0)*8,1);	//   SHUTDOWN
	sleep(50);
	jtag_inst(JSTART,0,NULL,NULL,16,1);							// 5. 6. TCK 12 cycle
	sleep(50);
	jtag_inst(CFG_IN,0,sht_data1,NULL,sizeof(sht_data1)*8,1);	// 7. GHIGH command
	sleep(50);
}

// CONFIG_START() : BoundaryScan [hARtBOJn
int jtag_start(void)
{
	BYTE ibuf[8];
	BYTE obuf[4];
	DWORD id , sts , rev;
	char *tname;

	// IDCODE read & show
	jtag_inst(IDCODE,1,NULL,obuf,32,1);
	id = byte_to_dword(obuf);
	switch(id & 0x0fffffff)
	{
	case 0x00608093: tname = "XC2S15"; break;
	case 0x0060c093: tname = "XC2S30"; break;
	case 0x00610093: tname = "XC2S50"; break;
	case 0x00614093: tname = "XC2S100"; break;
	case 0x00618093: tname = "XC2S150"; break;
	case 0x0061c093: tname = "XC2S200"; break;
	default: tname = "unknown";
	}
	printf("Device ID code %08XH : %s Rev.%d\n",id,tname,id>>28);

	if( (id == 0xffffffff || id == 0x00000000))
	{
		printf("JTAG DEVICE error\n");
		return 1;
	}

	/* do shutdown */
	jtag_status();
	jtag_shutdown();
	jtag_status();

	//Enter CFG_IN phase
	jtag_inst(CFG_IN,1,NULL,NULL,0,0);

	return 0;
}

// BoundaryScan [hARtBOf[^ݏ
int jtag_write(BYTE *data,DWORD size,int last)
{
	//phase 9,10,11
	jtag_dr(data,NULL,size*8,last);
	//ŌH
	if(last)
	{
		//phase 12,13,14,15,16,17,18
		jtag_inst(JSTART,0,NULL,NULL,14,1);
		//phase 19 RUN idle
		JTAG_TXRX(NULL,NULL,1,0,0);
		// show status
		jtag_status();
	}
	return 0;
}

/* -------------------- Windows DLL handling -------------------- */

static int dummy_init(DWORD port_address)
{
		return 0;
}

static HINSTANCE dllHandle;

// get DLL function
static int get_dll_func(void *func_ptr,char *name)
{
	*(void **)func_ptr = (void *)GetProcAddress(dllHandle,name);

	if( *(void **)func_ptr == NULL)
	{
		printf("DLL function '%s' is not found\n",name);
		return 0;
	}
	return 1;
}

static int dll_setup(char *dll_name,int mode)
{
	char *name;
	DWORD ver;

	/* Load DLL */
	dllHandle = LoadLibraryEx(dll_name,NULL,0);
	if(dllHandle == NULL)
	{
		printf("Can't open '%s.DLL'\n",dll_name);
		return 0;
	}

	/* */
	switch(mode)
	{
	case MODE_BSCAN:	// JTAG BoundaryScan
		sh_start = jtag_start;
		sh_write = jtag_write;
		if( 
			get_dll_func(&sh_init,"jtag_init") &
			get_dll_func(&sh_power,"jtag_power") &
			get_dll_func(&jtag_txrx,"jtag_txrx") &
			get_dll_func(&sh_end,"jtag_end")
		)
		{
			return 1; /* okay */
		}
	case MODE_SS:	// SlaveSerial interface
		sh_start = ss_start;
		sh_write = ss_write;
		if(
			get_dll_func(&sh_init,"ss_init") &
			get_dll_func(&sh_power,"ss_power") &
			get_dll_func(&ss_tx,"ss_tx") &
			get_dll_func(&ss_program,"ss_program") &
			get_dll_func(&ss_done,"ss_done") &
			get_dll_func(&sh_end,"ss_end")
		)
			return 1; /* okay */
	case MODE_SP:	// SlaveParallel interface
		break;
	}

	/* NG */
	FreeLibrary(dllHandle);
	dllHandle = NULL;
	return 0;
}

static void dll_end(void)
{
	if( dllHandle != NULL)
		FreeLibrary(dllHandle);
}
/* -------------------- Windows DLL handling -------------------- */


/* -------------------- optrion command handling -------------------- */

int get_str_cmd(const char **cmd_list , char *str)
{
	int i;

	for(i=0 ; cmd_list[i] != NULL ; i++)
	{
		if(!strcmp(str,cmd_list[i]))
			return i;
	}
	// not found
	return -1;
}

/*
	analyze one of option
	return == No. of parameter used
*/
int analyze_option(char *p1,char *p2)
{
	int param;
	char dummy[1] = {0x00};

	if(p1==NULL)
		return 0;

	strlwr(p1);
	if(p2==NULL)
		p2 = dummy;
	else
		strlwr(p2);

/* printf("OPTION '%s' '%s'\n",p1,p2); */

	if(*p1 == '-')
	{
		/* search option code */
		switch(get_str_cmd(impact_cmd , p1))
		{
		case OPT_PORT: // -port auto
			sscanf(p2,"%X",&port_addr);
			return 2;
		case OPT_BAUD: // -baud auto
			sscanf(p2,"%d",&baudrate);
			return 2;
		case OPT_MODE: // -mode [bscan/sserial/sparalell]
			param = get_str_cmd(mode_select , p2);
			if( param >=0)
				config_mode = param;
			return 2;
		case OPT_BITSTREAM: // -bitstream
			return 1;
		case OPT_JEDEC:	// -jedec
			return 1;
		case OPT_DRIVER: // -driver dllname
			strcpy(dll_name,p2);
			return 2;
		case OPT_BATCH:	// -f rsp_filename
			strcpy(rsp_name,p2);
			return 2;
		case OPT_CONTINUE:	// -continue
			continus_mode = 1;
			return 1;
		default:
		}
	}
	else
	{
		// bitstream/jedec_filename
		strcpy(filename,p1);
	}
	return 1;
}

void file_option(char *filepath)
{
	FILE *hndl;
	char buf[256] , *p1,*p2;

	// file open
	hndl = fopen(filepath,"rt");
	if( hndl==NULL)
		return;

	while( fgets(buf,255,hndl) != NULL)
	{
		p1 = strtok(buf," \n");
		p2 = strtok(NULL," \n");
		analyze_option(p1,p2);
	}
	fclose(hndl);
}

/* ------------------------------ MAIN ----------------------------- */

// C
int main(int argc,char *argv[])
{
	BIT_FILE *hndl = NULL;
	DWORD file_size;
	char probe_name[128];
	DWORD file_pos,tx_size;
	int last_block;
	int c , param;
	char *p;
	int err = 0;
	int ver_mjr , ver_mnr;
	int option_f;
	char last_date[64],last_time[64];

	// ^Cg\
	printf("\n\
Xilinx SpartanII Configrater with Cypress EZ-USB Ver.0.9\n\
Copyrght(c) 2002 Tatsuuki Satoh\n");

	// 
	if( argc<2)
	{
		printf("\n\
useage: spcusb [Xilinx_bit_file] [options]\n\
  options :\n\
       -port [address]  : port address\n\
       -baud [bps]      : baud rate\n\
       -mode bscan      : BoundaryScan  (JTAG) mode\n\
       -mode sserlal    : SlaveSerial   (CCLK) mode\n\
       -mode sparalell  : SlaveParalell (CCLK) mode\n\
       -bitstream       : [future]\n\
       -jedec           : [future]\n\
       -driver [dllname]: DLL driver slelect\n\
       -continue        : continus mode
       -f [rspname]     : use option in file\n\
");
		exit(1);
	}

	// R}hC̉
	port_addr = 0;
	baudrate = 0;
	config_mode = MODE_BSCAN;
	continus_mode = 0;

	// NIvV
	strcpy(dll_name,"spc_isp"); // default DLL name
	filename[0] = 0x00;
	rsp_name[0] = 0x00;
	option_f = 0;
	for( c=1 ; c<argc ; )
		c = c + analyze_option(argv[c],(c+1)<argc ? argv[c+1] : NULL);

	// .rspt@CLȂAt@CIvVǉ
	if(strstr(rsp_name,".rsp"))
	{
		/* wt@Cǂݍ */
		file_option(rsp_name);
	}

	/* ftH[grspt@CŌɏ㏑ */
	file_option("spcisp.rsp");

	//t@C.bitgqǉ
	if(!strstr(filename,".bit"))
		strcat(filename,".bit");

	err = 0;
	// hCo[DLL̃[h
	if( !dll_setup(dll_name,config_mode) )
		err = 6;

	// Probe Hardware Initialize
	if(!err)
	{
		err = PROBE_INIT(port_addr,baudrate,probe_name);
		switch(err)
		{
		case 0:
			printf("probe name : %s\n",probe_name);
			break;
		case 2: printf("NO Probe\n"); break;
		case 4: printf("NO Target\n"); break;
		}
	}

	printf("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");

	last_date[0] = last_time[0] = 0x00;
again:
	if(err<2)
		err = 0;

	if(!err)
	{
		if( continus_mode )
		{
			printf("Waiting for update '%s'\n",filename);
			while(1)
			{
				hndl = bitfile_open(filename);
				if(hndl == NULL)
					continue;
				if( !strcmp(last_date,hndl->date) && !strcmp(last_time,hndl->time))
				{
					bitfile_close(hndl);
					hndl = NULL;
					sleep(100);
					continue;
				}
				break;
			}
		}
		else
		{
			// t@C̃I[v
			hndl = bitfile_open(filename);
			if( hndl == NULL )
			{
				printf("Can't open bitstream file '%s'\n",filename);
				err = 1;
			}
		}
	}
	// bitstream t@C̏\
	if(!err)
	{
		file_size = hndl->bit_size;
		printf("MODE          %s\n",md_str[config_mode]);
		printf("ConfigFile    '%s'\n",filename);
		printf(" -Netname     '%s'\n"   ,hndl->netname);
		printf(" -TargetDeive '%s'\n"   ,hndl->targetname);
		printf(" -TimeStamp   '%s %s'\n",hndl->date,hndl->time);
		printf(" -ConfigSize  %dbits(%dbytes)\n",file_size*8,file_size);
		printf("---------------------------------------------------------------\n");
	}

	// Target Power Check
	if(!err)
	{
		if( !PROBE_POWER() )
		{
			printf("Target power down\n");
			err = 1;
		}
	}

	// Configration Jn
	if(!err)
	{
		err |= CONFIG_START();
		printf("Start Configraion\n");
	}

	// RtBO[Vf[^̑M
	if(!err)
	{
		for(file_pos=0; err==0 && file_pos<file_size ; file_pos += tx_size)
		{
			// ŏIubNH
			last_block = (file_size <= file_pos+TX_MAX);
			// ]
			tx_size = last_block ? (file_size - file_pos) : TX_MAX;

			//\
			printf("  Condifration bit %7d to -%7d\n",file_pos*8,(file_pos+tx_size)*8-1);

			// bitstreamt@C烊[h
			if( !bitfile_read(hndl,file_buffer,tx_size) )
			{
				printf("File Read Error");
				err |= 1;
				break;
			}
			// PubN̑Mf[^M{݊`FbNiŏIubNj
			err |= CONFIG_WRITE(file_buffer,tx_size,last_block);
		}
	}

	//RtBOt@C̃N[Y
	if(hndl)
	{
		if(!err)
		{
			strcpy(last_date,hndl->date);
			strcpy(last_time,hndl->time);
		}
		bitfile_close(hndl);
		hndl = NULL;
	}

	// ʕ\
	printf("%s\n" , err? "error!" : "Complete!");

	if( continus_mode && err<2)
	{
		if(err)
			sleep(1000);
		goto again;
	}

	// finish PROBE controll
	if(err < 6)
		PROBE_END();

	// DLL close
	dll_end();

	exit(err);
}

